Package org.eclipse.cdt.core.dom.ast.cpp

# Interface ICPPASTTypeIdExpression

All Superinterfaces:
  `IASTExpression`, `IASTImplicitDestructorNameOwner`, `IASTInitializerClause`, `IASTNode`, `IASTTypeIdExpression`, `ICPPASTExpression`, `ICPPASTInitializerClause`

public interface ICPPASTTypeIdExpression extends IASTTypeIdExpression, ICPPASTExpression

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`IASTExpression.ValueCategory`

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`op_typeid`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`EMPTY_EXPRESSION_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitDestructorNameOwner

`IMPLICIT_DESTRUCTOR_NAME`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTTypeIdExpression

`op_alignof, op_has_nothrow_assign, op_has_nothrow_constructor, op_has_nothrow_copy, op_has_trivial_assign, op_has_trivial_constructor, op_has_trivial_copy, op_has_trivial_destructor, op_has_virtual_destructor, op_is_abstract, op_is_class, op_is_empty, op_is_enum, op_is_final, op_is_literal_type, op_is_pod, op_is_polymorphic, op_is_standard_layout, op_is_trivial, op_is_trivially_copyable, op_is_union, op_sizeof, op_sizeofParameterPack, op_typeof, TYPE_ID`

## Method Summary

Modifier and Type
Method
Description
`ICPPASTTypeIdExpression`
`copy()`
Returns a mutable copy of the tree rooted at this node.
`ICPPASTTypeIdExpression`
`copy(IASTNode.CopyStyle style)`
Returns a mutable copy of the tree rooted at this node.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`getExpressionType, getValueCategory, isLValue`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitDestructorNameOwner

`getImplicitDestructorNames`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTTypeIdExpression

`getOperator, getTypeId, setOperator, setTypeId`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.cpp.ICPPASTInitializerClause

`getEvaluation`

## Field Details

### op_typeid

static final int op_typeid

See Also:
  - Constant Field Values

## Method Details

### copy

ICPPASTTypeIdExpression copy()
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTNode`
Specified by:
  `copy` in interface `IASTTypeIdExpression`
Since:
  5.1

### copy

ICPPASTTypeIdExpression copy(IASTNode.CopyStyle style)
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTNode`
Specified by:
  `copy` in interface `IASTTypeIdExpression`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3